## open-ath9k-htc-firmware 1.3-1

=== Makefile ===
GMP_VER=5.0.5
GMP_URL=http://ftp.gnu.org/gnu/gmp/gmp-$(GMP_VER).tar.bz2
GMP_TAR=gmp-$(GMP_VER).tar.bz2

MPFR_VER=3.1.1
MPFR_URL=http://ftp.gnu.org/gnu/mpfr/mpfr-$(MPFR_VER).tar.bz2
MPFR_TAR=mpfr-$(MPFR_VER).tar.bz2

MPC_VER=1.0.1
MPC_URL=http://ftp.gnu.org/gnu/mpc/mpc-$(MPC_VER).tar.gz
MPC_TAR=mpc-$(MPC_VER).tar.gz

BINUTILS_VER=2.23.1
BINUTILS_URL=http://ftp.gnu.org/gnu/binutils/binutils-$(BINUTILS_VER).tar.bz2
BINUTILS_TAR=binutils-$(BINUTILS_VER).tar.bz2

GCC_VER=4.7.2
GCC_URL=http://ftp.gnu.org/gnu/gcc/gcc-$(GCC_VER)/gcc-$(GCC_VER).tar.bz2
GCC_TAR=gcc-$(GCC_VER).tar.bz2

BASEDIR=$(shell pwd)
TOOLCHAIN_DIR=$(BASEDIR)/toolchain
TARGET=xtensa-elf

download:
	wget -N -P $(TOOLCHAIN_DIR)/dl $(GMP_URL)
	wget -N -P $(TOOLCHAIN_DIR)/dl $(MPFR_URL)
	wget -N -P $(TOOLCHAIN_DIR)/dl $(MPC_URL)
	wget -N -P $(TOOLCHAIN_DIR)/dl $(BINUTILS_URL)
	wget -N -P $(TOOLCHAIN_DIR)/dl $(GCC_URL)

all: download toolchain

gmp-$(GMP_VER):
	tar -C $(TOOLCHAIN_DIR)/dl -xjf $(TOOLCHAIN_DIR)/dl/$(GMP_TAR)

gmp: gmp-$(GMP_VER)
	mkdir -p $(TOOLCHAIN_DIR)/build/gmp
	cd $(TOOLCHAIN_DIR)/build/gmp; \
	$(TOOLCHAIN_DIR)/dl/$</configure --disable-shared --enable-static --prefix=$(TOOLCHAIN_DIR)/inst; \
	$(MAKE); $(MAKE) check;$(MAKE) install

mpfr-$(MPFR_VER):
	tar -C $(TOOLCHAIN_DIR)/dl -xjf $(TOOLCHAIN_DIR)/dl/$(MPFR_TAR)

mpfr: mpfr-$(MPFR_VER)
	mkdir -p $(TOOLCHAIN_DIR)/build/mpfr
	cd $(TOOLCHAIN_DIR)/build/mpfr; \
	$(TOOLCHAIN_DIR)/dl/$</configure --disable-shared --enable-static --with-gmp=$(TOOLCHAIN_DIR)/inst \
	--prefix=$(TOOLCHAIN_DIR)/inst; \
	$(MAKE); $(MAKE) check;$(MAKE) install

mpc-$(MPC_VER):
	tar -C $(TOOLCHAIN_DIR)/dl -zxvf $(TOOLCHAIN_DIR)/dl/$(MPC_TAR)

mpc: mpc-$(MPC_VER)
	mkdir -p $(TOOLCHAIN_DIR)/build/mpfc
	cd $(TOOLCHAIN_DIR)/build/mpfc; \
	$(TOOLCHAIN_DIR)/dl/$</configure --disable-shared --enable-static --with-gmp=$(TOOLCHAIN_DIR)/inst \
	--with-mpfr=$(TOOLCHAIN_DIR)/inst --prefix=$(TOOLCHAIN_DIR)/inst; \
	$(MAKE); $(MAKE) check;$(MAKE) install

binutils-$(BINUTILS_VER):
	tar -C $(TOOLCHAIN_DIR)/dl -xjf $(TOOLCHAIN_DIR)/dl/$(BINUTILS_TAR)
	patch -d $(TOOLCHAIN_DIR)/dl/$@ -p1 < local/patches/binutils.patch

binutils: binutils-$(BINUTILS_VER)
	mkdir -p $(TOOLCHAIN_DIR)/build/binutils
	cd $(TOOLCHAIN_DIR)/build/binutils; \
	$(TOOLCHAIN_DIR)/dl/$</configure --target=$(TARGET) --prefix=$(TOOLCHAIN_DIR)/inst; \
	$(MAKE) all; $(MAKE) install

gcc-$(GCC_VER):
	tar -C $(TOOLCHAIN_DIR)/dl -xjf $(TOOLCHAIN_DIR)/dl/$(GCC_TAR)
	patch -d $(TOOLCHAIN_DIR)/dl/$@ -p1 < local/patches/gcc.patch

gcc: gcc-$(GCC_VER)
	mkdir -p $(TOOLCHAIN_DIR)/build/gcc
	cd $(TOOLCHAIN_DIR)/build/gcc; \
	export PATH=$(TOOLCHAIN_DIR)/inst/bin:$(PATH); \
	$(TOOLCHAIN_DIR)/dl/$</configure --target=$(TARGET) --prefix=$(TOOLCHAIN_DIR)/inst \
	--enable-languages=c --disable-libssp --disable-shared --disable-libquadmath \
	--with-gmp=$(TOOLCHAIN_DIR)/inst \
	--with-mpfr=$(TOOLCHAIN_DIR)/inst \
	--with-mpc=$(TOOLCHAIN_DIR)/inst --with-newlib; \
	$(MAKE) all; $(MAKE) install

toolchain: gmp mpfr mpc binutils gcc

clean:
	rm -rf $(TOOLCHAIN_DIR)/build $(TOOLCHAIN_DIR)/inst

=== target_firmware/magpie_fw_dev/build/utility/Makefile ===
DIRS = bin2hex

all:
	@for i in $(DIRS) ; do $(MAKE) -C $$i || exit $? ; done

clean :
	@for i in $(DIRS) ; do $(MAKE) -C $$i clean; done

=== target_firmware/magpie_fw_dev/build/utility/adjust_dep/Makefile ===
TARGET = ../bin/adj_dep	# for Linux environment
#TARGET = ../bin/adj_dep.exe		# for CygWin environment

all: $(TARGET)

$(TARGET):
	gcc -o $(TARGET) adj_dep.c

install:
	cp adj_dep ../bin

clean:
	-rm $(TARGET)

=== target_firmware/magpie_fw_dev/build/utility/adjust_time/Makefile ===
TARGET = ../bin/adj_time		# for Linux environment
#TARGET = ../bin/adj_time.exe	# for CygWin environment

all: $(TARGET)

$(TARGET):
	gcc -o $(TARGET) adj_time.c

clean:
	-rm $(TARGET)

=== target_firmware/magpie_fw_dev/build/utility/athfw2lnx/Makefile ===
all: athfw2lnx

ifeq ($(ATH_FW),)
$(error "ERROR: usage: make ATH_FW=fw.c")
endif

athfw2lnx: athfw2lnx.c $(ATH_FW)
	gcc -o $@ athfw2lnx.c $(ATH_FW)

clean:
	rm -f athfw2lnx

=== target_firmware/magpie_fw_dev/build/utility/bin2hex/Makefile ===
TARGET = ../bin/bin2hex		# for Linux environment

E=echo

all: $(TARGET)

$(TARGET):
	gcc -o $(TARGET) bin2hex.c
	@$(E) "  CC " $@

clean:
	-rm $(TARGET)

=== target_firmware/magpie_fw_dev/build/utility/imghdr/Makefile ===
TARGET = ../bin/imghdr		# for Linux environment
#TARGET = ../bin/bin2hex.exe	# for CygWin environment

all: $(TARGET)

$(TARGET):
	gcc -o $(TARGET) imghdr.c

clean:
	-rm $(TARGET)

=== target_firmware/magpie_fw_dev/build/utility/patch_gen/Makefile ===
TARGET = ../bin/patch_gen		# for Linux environment
#TARGET = ../bin/_gen.exe	# for CygWin environment

INC = $(HOME)/project/src/inc

all: $(TARGET)

$(TARGET):
	gcc -o $(TARGET) -I$(INC) main.c patch.c


clean:
	-rm $(TARGET)

=== target_firmware/magpie_fw_dev/build/k2_1_0/image/k2_ram/Makefile ===
include $(MAGPIE_ROOT)/build/make_opt/Makefile.h

DIRS =  \
	$(PRJ_ROOT)/$(TARGET)/adf 		\
	$(PRJ_ROOT)/$(TARGET)/init		\
	$(PRJ_ROOT)/$(TARGET)/wmi		\
	$(PRJ_ROOT)/$(TARGET)/wlan		\
	$(PRJ_ROOT)/$(TARGET)/carrier_apd 	\
	$(PRJ_ROOT)/$(TARGET)/cmnos		\
	$(PRJ_ROOT)/$(TARGET)/htc 		\
	$(PRJ_ROOT)/$(TARGET)/hif 		\
	$(PRJ_ROOT)/$(TARGET)/buf_pool

COMPONENTS_sw.ram =			\
	$(LIB_PATH)/libcmnos.a	 	\
	$(LIB_PATH)/libadf.a  		\
	$(LIB_PATH)/libwmi.a		\
	$(LIB_PATH)/libwlan.a		\
	$(LIB_PATH)/libcarrier_apd.a    \
	$(LIB_PATH)/libbuf_pool.a	\
	$(LIB_PATH)/libhif.a		\
	$(LIB_PATH)/libhtc.a


ifeq ($(debug),1)
LINKFLAGS_sw.ram =			\
	-T./target.ram_debug.ld		\
	--start-group			\
	$(COMPONENTS_sw.ram)            \
	--end-group
else
LINKFLAGS_sw.ram =			\
	-T./target.ram.ld		\
	--start-group			\
	$(COMPONENTS_sw.ram)            \
	--end-group
endif

all: util toolchain_prep
	@for i in $(DIRS) ; do $(MAKE) -C $$i all CC=$(XCC) LD=$(XLD) AR=$(XAR) || exit ; done

dep: util toolchain_prep
	@for i in $(DIRS) ; do $(MAKE) -C $$i dep CC=$(XCC) LD=$(XLD) AR=$(XAR) || exit ; done

clean:
	find $(PRJ_ROOT)/ram -name "*.o" -exec rm -f {} \;
	rm -rf $(PRJ_ROOT)/lib/ram/*.a
	@for i in $(DIRS) ; do echo $$i; $(MAKE) -C $$i clean; done
	rm -f *.bin *.hex *.objdump *.out *.map *.c *.fw *.fw.back *.c.back
	rm -f ../../../utility/athfw2lnx/athfw2lnx

init:	toolchain_prep
	for i in $(DIRS) ; do $(MAKE) -C $$i init CC=$(XCC) LD=$(XLD) AR=$(XAR) ; done

build: binary image

binary:
	$(XLD) $(PRJ_ROOT)/ram/init/obj/app_start.o $(PRJ_ROOT)/ram/init/obj/init.o $(PRJ_ROOT)/ram/init/obj/magpie.o $(LINKFLAGS_sw.ram) -Map $(PRJNAME).map -o $(PRJNAME).out

toolchain_prep:
ifeq ($(XTENSA_TOOL_INSTALLED),0)
	@cd ../../../toolchain && \
	(test -d tools) || tar xvzf toolchain.tgz
endif

image:
	$(XOBJCOPY)						\
		--change-section-lma .text-0x400000		\
		--change-section-vma .text-0x400000 		\
		-O binary $(PRJNAME).out $(PRJNAME).bin
	rm -f ../../../utility/athfw2lnx/athfw2lnx
	$(shell cp -f fwu.c fwu.c.back 2> /dev/null)
	$(shell cp -f htc_9271.fw htc_9271.fw.back 2> /dev/null)
	$(BIN2HEX) $(PRJNAME).bin fwu.c 0 $(MAGPIE_IF)
	$(MAKE) -C ../../../utility/athfw2lnx ATH_FW=$(PRJ_ROOT)/image/k2_ram/fwu.c
	$(shell ../../../utility/athfw2lnx/athfw2lnx > htc_9271.fw)

util:
	$(MAKE) -C ../../../utility/ clean
	$(MAKE) -C ../../../utility/ all

=== target_firmware/magpie_fw_dev/build/k2_1_0/ram/adf/Makefile ===
include $(MAGPIE_ROOT)/build/make_opt/Makefile.h


#
# Sub-system source main path
#
# !!Customize!!

export LAYERNAME = adf

#
# Sub-system source main path
#

export SSMPATH = $(MAGPIE_ROOT)/target/$(LAYERNAME)


#
# Sub-system object search path for GNU tool chain
#
# !!Customize!!

# export SSOBJPATH = $(PRJ_ROOT)/build/$(TARGET)/$(LAYERNAME)/obj


export SSOBJPATH = $(PRJ_ROOT)/$(TARGET)/$(LAYERNAME)/obj

#
# Sub-system/module list at this layer
#
# !!Customize!!

SUBDIRS = .
#DIRS = net os nbuf


#
# Archive for this package
#
# !!Customize!!

export L_TARGET = $(LIB_PATH)/libadf.a


#
# Targets
#

all:
	for i in $(SUBDIRS) ; do $(MAKE) -C $$i -f Makefile.ss all || exit $?; done


dep:
	for i in $(SUBDIRS) ; do $(MAKE) -C $$i -f Makefile.ss dep || exit $?; done

clean:
	$(MAKE) clean -f Makefile.ss

init:
	$(MAKE) -f Makefile.ss init

=== target_firmware/magpie_fw_dev/build/k2_1_0/ram/buf_pool/Makefile ===
include $(MAGPIE_ROOT)/build/make_opt/Makefile.h


#
# Sub-system source main path
#
# !!Customize!!

export SSNAME = buf_pool


#
# Sub-system source main path
#

export SSMPATH = $(MAGPIE_ROOT)/target/$(SSNAME)


#
# Sub-system object search path for GNU tool chain
#
# !!Customize!!

export SSOBJPATH = $(PRJ_ROOT)/$(TARGET)/$(SSNAME)/obj


#
# Sub-system/module list at this layer
#
# !!Customize!!

SUBDIRS = .


#
# Archive for this package
#
# !!Customize!!

export L_TARGET = $(LIB_PATH)/libbuf_pool.a


#
# Targets
#

all:
	for i in $(SUBDIRS) ; do $(MAKE) -C $$i -f Makefile.ss all || exit $?; done


dep:
	for i in $(SUBDIRS) ; do $(MAKE) -C $$i -f Makefile.ss dep || exit $?; done

clean:
	$(MAKE) clean -f Makefile.ss

init:
	$(MAKE) -f Makefile.ss init

=== target_firmware/magpie_fw_dev/build/k2_1_0/ram/carrier_apd/Makefile ===
include $(MAGPIE_ROOT)/build/make_opt/Makefile.h


#
# Sub-system source main path
#
# !!Customize!!

export LAYERNAME = carrier_apd
export SLAYERNAME = ../wlan


#
# Sub-system source main path
#

export SSMPATH = $(MAGPIE_ROOT)/$(SLAYERNAME)


#
# Sub-system object search path for GNU tool chain
#
# !!Customize!!

# export SSOBJPATH = $(PRJ_ROOT)/build/$(TARGET)/$(LAYERNAME)/usb/obj

export SSOBJPATH = $(PRJ_ROOT)/$(TARGET)/$(LAYERNAME)/$(SLAYERNAME)/$(SSNAME)/obj

#
# Sub-system/module list at this layer
#
# !!Customize!!

SUBDIRS = .


#
# Archive for this package
#
# !!Customize!!

export L_TARGET = $(LIB_PATH)/libcarrier_apd.a


#
# Targets
#

all:
	for i in $(SUBDIRS) ; do $(MAKE) -C $$i -f Makefile.ss all || exit $?; done

dep:
	for i in $(SUBDIRS) ; do $(MAKE) -C $$i -f Makefile.ss dep || exit $?; done

clean:
	$(MAKE) clean -f Makefile.ss

init:
	$(MAKE) -f Makefile.ss init

=== debian/changelog ===
open-ath9k-htc-firmware (1.3-1) toutatis; urgency=low

  * Added udeb packaging

 -- Ruben Rodriguez <ruben@trisquel.info>  Sat, 23 Feb 2014 00:00:00 +0000

open-ath9k-htc-firmware (1.3) toutatis; urgency=low

  * Initial release

 -- Ruben Rodriguez <ruben@trisquel.info>  Sat, 22 Dec 2013 00:00:00 +0000

=== debian/control ===
Source: open-ath9k-htc-firmware
Section: kernel
Priority: optional
Maintainer: Ruben Rodriguez <ruben@trisquel.info>
Build-Depends:
 wget,
 build-essential,
 cmake,
 git,
 m4
Standards-Version: 3.9.2
Homepage: https://wiki.debian.org/ath9k_htc/open_firmware
Vcs-Git: https://github.com/qca/open-ath9k-htc-firmware.git

Package: open-ath9k-htc-firmware
Architecture: all
Description: Firmware for ath9k_htc
 Free software firmware for Atheros AR9271, AR7010 devices

Package: open-ath9k-htc-firmware-udeb
Section: debian-installer
XC-Package-Type: udeb
Architecture: all
Description: Firmware for ath9k_htc
 Free software firmware for Atheros AR9271, AR7010 devices

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	make toolchain
	./build

override_dh_auto_clean:
	rm -f rm -rf toolchain/build toolchain/inst

## open-ath9k-htc-firmware 1.4.0-81

=== Makefile ===
GMP_VER=6.1.1
GMP_URL=https://ftp.gnu.org/gnu/gmp/gmp-$(GMP_VER).tar.bz2
GMP_TAR=gmp-$(GMP_VER).tar.bz2
GMP_DIR=gmp-$(GMP_VER)
GMP_SUM=a8109865f2893f1373b0a8ed5ff7429de8db696fc451b1036bd7bdf95bbeffd6

MPFR_VER=3.1.4
MPFR_URL=https://ftp.gnu.org/gnu/mpfr/mpfr-$(MPFR_VER).tar.bz2
MPFR_TAR=mpfr-$(MPFR_VER).tar.bz2
MPFR_DIR=mpfr-$(MPFR_VER)
MPFR_SUM=d3103a80cdad2407ed581f3618c4bed04e0c92d1cf771a65ead662cc397f7775

MPC_VER=1.0.3
MPC_URL=https://ftp.gnu.org/gnu/mpc/mpc-$(MPC_VER).tar.gz
MPC_TAR=mpc-$(MPC_VER).tar.gz
MPC_DIR=mpc-$(MPC_VER)
MPC_SUM=617decc6ea09889fb08ede330917a00b16809b8db88c29c31bfbb49cbf88ecc3

BINUTILS_VER=2.27
BINUTILS_URL=https://ftp.gnu.org/gnu/binutils/binutils-$(BINUTILS_VER).tar.bz2
BINUTILS_TAR=binutils-$(BINUTILS_VER).tar.bz2
BINUTILS_DIR=binutils-$(BINUTILS_VER)
BINUTILS_PATCHES=local/patches/binutils.patch local/patches/binutils-2.27_fixup.patch
BINUTILS_SUM=369737ce51587f92466041a97ab7d2358c6d9e1b6490b3940eb09fb0a9a6ac88

GCC_VER=6.2.0
GCC_URL=https://ftp.gnu.org/gnu/gcc/gcc-$(GCC_VER)/gcc-$(GCC_VER).tar.bz2
GCC_TAR=gcc-$(GCC_VER).tar.bz2
GCC_DIR=gcc-$(GCC_VER)
GCC_PATCHES=local/patches/gcc.patch
GCC_SUM=9944589fc722d3e66308c0ce5257788ebd7872982a718aa2516123940671b7c5

BASEDIR=$(shell pwd)
TOOLCHAIN_DIR=$(BASEDIR)/toolchain
TARGET=xtensa-elf
DL_DIR=$(TOOLCHAIN_DIR)/dl
BUILD_DIR=$(TOOLCHAIN_DIR)/build

all: toolchain

# 1: package name
# 2: configure arguments
# 3: make command
define Common/Compile
	mkdir -p $(BUILD_DIR)/$($(1)_DIR)
	+cd $(BUILD_DIR)/$($(1)_DIR) && \
	$(DL_DIR)/$($(1)_DIR)/configure \
		--prefix=$(TOOLCHAIN_DIR)/inst \
		$(2) && \
	$(3)
endef

define GMP/Compile
	$(call Common/Compile,GMP, \
		--disable-shared --enable-static, \
		$(MAKE) && $(MAKE) check && $(MAKE) -j1 install \
	)
endef

define MPFR/Compile
	$(call Common/Compile,MPFR, \
		--disable-shared --enable-static \
		--with-gmp=$(TOOLCHAIN_DIR)/inst, \
		$(MAKE) && $(MAKE) check && $(MAKE) -j1 install \
	)
endef

define MPC/Compile
	$(call Common/Compile,MPC, \
		--disable-shared --enable-static \
		--with-gmp=$(TOOLCHAIN_DIR)/inst \
		--with-mpfr=$(TOOLCHAIN_DIR)/inst, \
		$(MAKE) && $(MAKE) check && $(MAKE) -j1 install \
	)
endef

define BINUTILS/Compile
	$(call Common/Compile,BINUTILS, \
		--target=$(TARGET) \
		--disable-werror, \
		$(MAKE) && $(MAKE) -j1 install \
	)
endef

define GCC/Compile
	$(call Common/Compile,GCC, \
		--target=$(TARGET) \
		--enable-languages=c \
		--disable-libssp \
		--disable-shared \
		--disable-libquadmath \
		--with-gmp=$(TOOLCHAIN_DIR)/inst \
		--with-mpfr=$(TOOLCHAIN_DIR)/inst \
		--with-mpc=$(TOOLCHAIN_DIR)/inst \
		--with-newlib, \
		$(MAKE) && $(MAKE) -j1 install \
	)
endef

# 1: package name
# 2: dependencies on other packages
define Build
$(DL_DIR)/$($(1)_TAR):
	mkdir -p $(DL_DIR)
	wget -N -P $(DL_DIR) $($(1)_URL)
	printf "%s  %s\n" $($(1)_SUM) $$@ | sha256sum -c

$(DL_DIR)/$($(1)_DIR)/.prepared: $(DL_DIR)/$($(1)_TAR)
	tar -C $(DL_DIR) -x$(if $(findstring bz2,$($(1)_TAR)),j,z)f $(DL_DIR)/$($(1)_TAR)
	$(if $($(1)_PATCHES), \
		cat $($(1)_PATCHES) | \
		patch -p1 -d $(DL_DIR)/$($(1)_DIR))
	touch $$@

$(1)_DEPENDS = $(foreach pkg,$(2),$(BUILD_DIR)/$($(pkg)_DIR)/.built)
$(BUILD_DIR)/$($(1)_DIR)/.built: $(DL_DIR)/$($(1)_DIR)/.prepared $$($(1)_DEPENDS)
	mkdir -p $(BUILD_DIR)/$($(1)_DIR)
	$($(1)/Compile)
	touch $$@

clean-dl-$(1):
	rm -rf $(DL_DIR)/$($(1)_DIR)

toolchain: $(BUILD_DIR)/$($(1)_DIR)/.built
clean-dl: clean-dl-$(1)
download: $(DL_DIR)/$($(1)_DIR)/.prepared

endef

all: toolchain firmware
toolchain-clean:
	rm -rf $(TOOLCHAIN_DIR)/build $(TOOLCHAIN_DIR)/inst
clean-dl:
download:
toolchain:

clean:
	$(MAKE) -C target_firmware clean

firmware: toolchain
	+$(MAKE) -C target_firmware

.PHONY: all toolchain-clean clean clean-dl download toolchain firmware

$(eval $(call Build,GMP))
$(eval $(call Build,MPFR,GMP))
$(eval $(call Build,MPC,GMP MPFR))
$(eval $(call Build,BINUTILS))
$(eval $(call Build,GCC,MPC MPFR))

=== target_firmware/CMakeLists.txt ===
##
 # Copyright (c) 2013 Qualcomm Atheros, Inc.
 #
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted (subject to the limitations in the
 # disclaimer below) provided that the following conditions are met:
 #
 #  * Redistributions of source code must retain the above copyright
 #    notice, this list of conditions and the following disclaimer.
 #
 #  * Redistributions in binary form must reproduce the above copyright
 #    notice, this list of conditions and the following disclaimer in the
 #    documentation and/or other materials provided with the
 #    distribution.
 #
 #  * Neither the name of Qualcomm Atheros nor the names of its
 #    contributors may be used to endorse or promote products derived
 #    from this software without specific prior written permission.
 #
 # NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE
 # GRANTED BY THIS LICENSE.  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 # HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
 # WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 # MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 # DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 # LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 # BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 # WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 # OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 # IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ##

SET(CMAKE_C_COMPILER_WORKS 1)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT(ath9k_firmware NONE)
ENABLE_LANGUAGE(C)

ADD_DEFINITIONS(
	-g -Os
	-Wunused-label
	-Wunused-variable
	-Wunused-value
	-Wpointer-arith
	-Wundef
	-nostdlib
	-Wundef
	-Wunused-but-set-variable
)
ADD_DEFINITIONS(
	-D_RAM_
	-DBIG_ENDIAN -D_BYTE_ORDER=_BIG_ENDIAN
	-D__XTENSA__
	-DFUSION_USB_FW -DRX_SCATTER
	-DFUSION_USB_ENABLE_TX_STREAM -DFUSION_USB_ENABLE_RX_STREAM
	-DATH_ENABLE_CABQ
)

SET(SOURCES
	magpie_fw_dev/target/init/app_start.c
	magpie_fw_dev/target/init/init.c
	magpie_fw_dev/target/init/magpie.c
	magpie_fw_dev/target/adf/adf_nbuf.c
	magpie_fw_dev/target/adf/adf_net.c
	magpie_fw_dev/target/adf/adf_os_defer_pvt.c
	magpie_fw_dev/target/adf/adf_os_dma.c
	magpie_fw_dev/target/adf/adf_os_irq_pvt.c
	magpie_fw_dev/target/adf/adf_os_timer.c
	magpie_fw_dev/target/buf_pool/buf_pool_static.c
	magpie_fw_dev/target/cmnos/dbg_api.c
	magpie_fw_dev/target/cmnos/cmnos_sflash.c
	magpie_fw_dev/target/hif/usb_api_main_patch.c
	wlan/ah.c
	wlan/ah_osdep.c
	wlan/ar5416Phy.c
	wlan/ar5416_hw.c
	wlan/ar5416_phy.c
	wlan/ratectrl_11n_ln.c
	wlan/if_owl.c
	wlan/if_ath.c
	wlan/if_ath_pci.c
	magpie_fw_dev/target/wlan/wlan_pci.c
	wlan/ieee80211_output.c
	magpie_fw_dev/target/htc/htc.c
	magpie_fw_dev/target/wmi/wmi_svc.c
)

IF(TARGET_K2)
	SET(SOURCES ${SOURCES}
		magpie_fw_dev/target/hif/k2_HIF_usb_patch.c
		magpie_fw_dev/target/hif/usb_api_k2_patch.c
	)
	SET(LIBS ${LIBS} hif)
	ADD_DEFINITIONS(-DPROJECT_K2)
	SET(PLATFORM_NAME k2)
	SET(SOURCES ${SOURCES}
		magpie_fw_dev/target/cmnos/k2_cmnos_clock_patch.c
		magpie_fw_dev/target/cmnos/k2_fw_cmnos_printf.c
	)
	SET(FIRMWARE_NAME htc_9271.fw)
ELSEIF(TARGET_MAGPIE)
	ADD_DEFINITIONS(
		-DROM_VER_1_1 -D_ROM_1_1_
		-DPROJECT_MAGPIE
		-DMAGPIE_MERLIN
	)
	SET(SOURCES ${SOURCES}
		magpie_fw_dev/target/hif/usb_api_magpie_patch.c
		magpie_fw_dev/target/rompatch/cmnos_clock_patch.c
		magpie_fw_dev/target/rompatch/HIF_usb_patch.c
	)
	INCLUDE_DIRECTORIES(
		${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/adf
	)
	SET(PLATFORM_NAME magpie)
	SET(FIRMWARE_NAME htc_7010.fw)
ELSE()
	MESSAGE(FATAL_ERROR "Unknown target name")
ENDIF()

INCLUDE_DIRECTORIES(
	${CMAKE_SOURCE_DIR}/include
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/inc
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/inc/xtensa-elf
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/inc/${PLATFORM_NAME}
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/inc/${PLATFORM_NAME}/${PLATFORM_NAME}
	${CMAKE_SOURCE_DIR}/wlan
	${CMAKE_SOURCE_DIR}/wlan/include
	${CMAKE_SOURCE_DIR}/wlan/include/${PLATFORM_NAME}
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/wlan
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/cmnos
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/wmi
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/adf
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/buf_pool
	${CMAKE_SOURCE_DIR}/magpie_fw_dev/target/htc
)

ADD_LIBRARY(firmware ${SOURCES})

ADD_CUSTOM_COMMAND(
	OUTPUT fw.elf
	DEPENDS firmware
	COMMAND ${CMAKE_C_COMPILER}
		-nostdlib
		-fno-lto
		-Wl,--start-group
		${CMAKE_BINARY_DIR}/libfirmware.a
		-Wl,--end-group
		-Wl,-T,${CMAKE_SOURCE_DIR}/ram-${PLATFORM_NAME}.ld
		-Wl,-T,${CMAKE_SOURCE_DIR}/rom-addrs-${PLATFORM_NAME}.ld
		-o fw.elf
)
ADD_CUSTOM_COMMAND(
	OUTPUT fw.bin
	DEPENDS fw.elf
	COMMAND ${CMAKE_OBJCOPY}
		--change-section-lma .boot-0x400000
		--change-section-vma .boot-0x400000
		--change-section-lma .text-0x400000
		--change-section-vma .text-0x400000
		-O binary fw.elf fw.bin
)
ADD_CUSTOM_COMMAND(
	OUTPUT ${FIRMWARE_NAME}
	DEPENDS fw.bin
	COMMAND ${CMAKE_SOURCE_DIR}/firmware-crc.pl < fw.bin > ${FIRMWARE_NAME}
)
ADD_CUSTOM_TARGET(gen-firmware ALL DEPENDS ${FIRMWARE_NAME})

## open-ath9k-htc-firmware 1.4.0-81-gf206e56+dfsg

=== debian/changelog ===
open-ath9k-htc-firmware (1.4.0-81-gf206e56+dfsg-2) unstable; urgency=low

  * Set "Auto-Built-Package: debug-symbols" for -dbgsym package.

 -- Oleksij Rempel <linux@rempel-privat.de>  Sat, 29 Apr 2017 17:41:41 +0200

open-ath9k-htc-firmware (1.4.0-81-gf206e56+dfsg-1) unstable; urgency=low

  * Initial Release. Closes: #751339, #711470

 -- Oleksij Rempel <linux@rempel-privat.de>  Sun, 25 Sep 2016 17:24:10 +0000

=== debian/control ===
Source: open-ath9k-htc-firmware
Maintainer: Oleksij Rempel <linux@rempel-privat.de>
Uploaders:
 Paul Fertser <fercerpav@gmail.com>,
Section: misc
Priority: extra
Build-Depends:
 binutils-source,
 bison,
 cmake,
 debhelper (>= 10),
 flex,
 gcc-6-source,
 libmpc-dev,
Standards-Version: 3.9.8
Homepage: https://github.com/qca/open-ath9k-htc-firmware
Vcs-Browser: https://github.com/olerem/firmware-ath9k-htc
Vcs-Git: https://github.com/olerem/firmware-ath9k-htc

Package: firmware-ath9k-htc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: QCA ath9k-htc Firmware
 Opensource version of QCA ath9k-htc Firmware.
 Supported chips are: ar9271 and ar7010

Package: firmware-ath9k-htc-dbgsym
Architecture: all
Multi-Arch: foreign
Auto-Built-Package: debug-symbols
Section: debug
Depends:
 ${misc:Depends},
Description: QCA ath9k-htc Firmware ELF file
 Full unstripped ELF file for debugging the opensource version of
 QCA ath9k-htc Firmware. Supported chips are: ar9271 and ar7010.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%open-ath9k-htc-firmware-$1.tar.gz%, \
      repacksuffix=+dfsg" \
    https://github.com/qca/open-ath9k-htc-firmware/tags \
        (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## open-ath9k-htc-firmware 1.4.0-97

=== Makefile ===
--- 
+++ 
@@ -23,12 +23,12 @@
 BINUTILS_PATCHES=local/patches/binutils.patch local/patches/binutils-2.27_fixup.patch
 BINUTILS_SUM=369737ce51587f92466041a97ab7d2358c6d9e1b6490b3940eb09fb0a9a6ac88
 
-GCC_VER=6.2.0
+GCC_VER=6.3.0
 GCC_URL=https://ftp.gnu.org/gnu/gcc/gcc-$(GCC_VER)/gcc-$(GCC_VER).tar.bz2
 GCC_TAR=gcc-$(GCC_VER).tar.bz2
 GCC_DIR=gcc-$(GCC_VER)
-GCC_PATCHES=local/patches/gcc.patch
-GCC_SUM=9944589fc722d3e66308c0ce5257788ebd7872982a718aa2516123940671b7c5
+GCC_PATCHES=local/patches/gcc.patch local/patches/gcc-6.3.0_fixup.patch
+GCC_SUM=f06ae7f3f790fbf0f018f6d40e844451e6bc3b7bc96e128e63b09825c1f8b29f
 
 BASEDIR=$(shell pwd)
 TOOLCHAIN_DIR=$(BASEDIR)/toolchain
@@ -103,7 +103,7 @@
 $(DL_DIR)/$($(1)_TAR):
 	mkdir -p $(DL_DIR)
 	wget -N -P $(DL_DIR) $($(1)_URL)
-	printf "%s  %s\n" $($(1)_SUM) $$@ | sha256sum -c
+	printf "%s  %s\n" $($(1)_SUM) $$@ | shasum -a 256 -c
 
 $(DL_DIR)/$($(1)_DIR)/.prepared: $(DL_DIR)/$($(1)_TAR)
 	tar -C $(DL_DIR) -x$(if $(findstring bz2,$($(1)_TAR)),j,z)f $(DL_DIR)/$($(1)_TAR)

## open-ath9k-htc-firmware 1.4.0-97-g75b3e59+dfsg

=== debian/changelog ===
open-ath9k-htc-firmware (1.4.0-97-g75b3e59+dfsg-3) unstable; urgency=medium

  * fix gcc version in debian/cross-toolchain.mk

 -- Oleksij Rempel <linux@rempel-privat.de>  Fri, 21 Dec 2018 11:00:25 +0000

open-ath9k-htc-firmware (1.4.0-97-g75b3e59+dfsg-2) unstable; urgency=medium

  * update to gcc 8.2.0 (Closes: #915737)
  * update to Standards-Version: 4.2.1

 -- Oleksij Rempel <linux@rempel-privat.de>  Wed, 19 Dec 2018 17:12:07 +0000

open-ath9k-htc-firmware (1.4.0-97-g75b3e59+dfsg-1) unstable; urgency=medium

  * update to latest upstream version 1.4.0-97-g75b3e59

 -- Oleksij Rempel <linux@rempel-privat.de>  Mon, 18 Dec 2017 09:13:38 +0000

open-ath9k-htc-firmware (1.4.0-81-gf206e56+dfsg-3) unstable; urgency=medium

  * Use GCC 7

 -- Oleksij Rempel <linux@rempel-privat.de>  Tue, 12 Dec 2017 17:10:53 +0000

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,16 @@
 Uploaders:
  Paul Fertser <fercerpav@gmail.com>,
 Section: misc
-Priority: extra
+Priority: optional
 Build-Depends:
  binutils-source,
  bison,
  cmake,
  debhelper (>= 10),
  flex,
- gcc-6-source,
+ gcc-8-source,
  libmpc-dev,
-Standards-Version: 3.9.8
+Standards-Version: 4.2.1
 Homepage: https://github.com/qca/open-ath9k-htc-firmware
 Vcs-Browser: https://github.com/olerem/firmware-ath9k-htc
 Vcs-Git: https://github.com/olerem/firmware-ath9k-htc

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%open-ath9k-htc-firmware-$1.tar.gz%, \
      repacksuffix=+dfsg, \
      dversionmangle=s/\+dfsg//" \
    https://github.com/qca/open-ath9k-htc-firmware/tags \
        (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## open-ath9k-htc-firmware 1.4.0-106

=== target_firmware/CMakeLists.txt ===
--- 
+++ 
@@ -46,10 +46,10 @@
 	-Wunused-variable
 	-Wunused-value
 	-Wpointer-arith
-	-Wundef
 	-nostdlib
 	-Wundef
 	-Wunused-but-set-variable
+	-Wmaybe-uninitialized
 )
 ADD_DEFINITIONS(
 	-D_RAM_

## open-ath9k-htc-firmware 1.4.0-106-gc583009+dfsg1

=== debian/changelog ===
open-ath9k-htc-firmware (1.4.0-106-gc583009+dfsg1-1ubuntu1) impish; urgency=medium

  [ John Scott ]
  * Build cross toolchain with Binutils 2.36 and GCC 11 with patch.

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 31 Aug 2021 08:28:05 +0000

open-ath9k-htc-firmware (1.4.0-106-gc583009+dfsg1-1) unstable; urgency=medium

  * Adopt package and designate myself as maintainer.
    - Thanks to Oleksij Rempel for his contributions in packaging,
      upstream, and helping with this release.
  * New upstream snapshot.
    - Build the cross toolchain with GCC 10 and Binutils >= 2.34.
      (Closes: #944169, #951891)
  * Drop the debugging symbols package, as it's generally not useful.
    (Closes: #873727)
  * NEWS: Due to a bug in wpasupplicant, ath9k_htc devices often failed
    connections using MAC address randomization, which is enabled by default
    with NetworkManager. Fixes are available as wpasupplicant updates in
    releases Stretch and later.
    (Resolves: #870159, #895696, #939075, #954457, #954861)

 -- John Scott <jscott@posteo.net>  Fri, 04 Dec 2020 18:57:57 -0500

=== debian/control ===
Source: open-ath9k-htc-firmware
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: John Scott <jscott@posteo.net>
Section: kernel
Priority: optional
Build-Depends:
 binutils-source (>= 2.36),
 bison,
 cmake,
 debhelper-compat (= 13),
 flex,
 gcc-11-source,
 libmpc-dev,
 zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 4.1.2
Homepage: https://github.com/qca/open-ath9k-htc-firmware

Package: firmware-ath9k-htc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: firmware for AR7010 and AR9271 USB wireless adapters
 The Qualcomm Atheros AR7010 and AR9271 chipsets are used in USB
 wireless adapters which are 802.11n-capable. This package contains
 the free firmware they require to function, and which gets loaded
 onto the devices during use.

=== debian/rules ===
#!/usr/bin/make -f
export DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include debian/cross-toolchain.mk

# Stack protector needs to be disabled since that entails linking to libssp.
# Other hardening flags likewise cause more problems than they solve.
export DEB_BUILD_MAINT_OPTIONS=hardening=-all

# This avoids clashing with the file in firmware-nonfree.
FW_FILENAME_VER = 1.dev.0

%:
	dh $@

override_dh_auto_build-indep: $(stamp)gcc_xtensa-elf
	dh_auto_build --buildsystem=makefile --sourcedir=target_firmware -- CROSS_COMPILE="$(toolchain_dir)/bin/xtensa-elf-"

override_dh_auto_clean:
	dh_auto_clean --buildsystem=makefile --sourcedir=target_firmware -- CROSS_COMPILE="$(toolchain_dir)/bin/xtensa-elf-"

execute_before_dh_install:
	mv target_firmware/htc_9271.fw target_firmware/htc_9271-$(FW_FILENAME_VER).fw
	mv target_firmware/htc_7010.fw target_firmware/htc_7010-$(FW_FILENAME_VER).fw

## open-ath9k-htc-firmware 1.4.0-108-gd856466+dfsg1

=== debian/changelog ===
open-ath9k-htc-firmware (1.4.0-108-gd856466+dfsg1-1) unstable; urgency=medium

  * Add package version control info.
  * Clean up the copyright file.
    - Distinguish the BSD 3-Clause Clear variant from the conventional one.
    - Make conformant to DEP-5 specification for machine readability.
  * Build cross toolchain with Binutils 2.36 and GCC 12 with patch.
  * Drop the BSD-4 advertising clause. (Closes: #1011438)
    Thanks to Bastian Germann for coordinating this upstream.
  * Move the Salsa repo to the Debian collaborative maintenance namespace.

 -- John Scott <jscott@posteo.net>  Thu, 01 Jul 2021 20:05:59 -0400

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: open-ath9k-htc-firmware
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: John Scott <jscott@posteo.net>
+Maintainer: John Scott <jscott@posteo.net>
 Section: kernel
 Priority: optional
 Build-Depends:
@@ -9,11 +8,13 @@
  cmake,
  debhelper-compat (= 13),
  flex,
- gcc-11-source,
+ gcc-12-source,
  libmpc-dev,
  zlib1g-dev
 Rules-Requires-Root: no
-Standards-Version: 4.1.2
+Standards-Version: 4.5.1
+Vcs-Browser: https://salsa.debian.org/debian/open-ath9k-htc-firmware
+Vcs-Git: https://salsa.debian.org/debian/open-ath9k-htc-firmware.git
 Homepage: https://github.com/qca/open-ath9k-htc-firmware
 
 Package: firmware-ath9k-htc

=== debian/rules ===
#!/usr/bin/make -f
export DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include debian/cross-toolchain.mk

# Stack protector needs to be disabled since that entails linking to libssp.
# Other hardening flags likewise cause more problems than they solve.
export DEB_BUILD_MAINT_OPTIONS=hardening=-all

# This avoids clashing with the file in firmware-nonfree.
FW_FILENAME_VER = 1.dev.0

%:
	CROSS_COMPILE="$(toolchain_dir)/bin/xtensa-elf-" \
	dh $@ --buildsystem=makefile --sourcedirectory=target_firmware

override_dh_auto_build: $(stamp)gcc_xtensa-elf
	dh_auto_build --

execute_before_dh_install:
	if [ -f target_firmware/htc_9271.fw ]; \
	then mv target_firmware/htc_9271.fw target_firmware/htc_9271-$(FW_FILENAME_VER).fw; \
	fi
	if [ -f target_firmware/htc_7010.fw ]; \
	then mv target_firmware/htc_7010.fw target_firmware/htc_7010-$(FW_FILENAME_VER).fw; \
	fi

## open-ath9k-htc-firmware 1.4.0-110

=== target_firmware/Makefile ===
##
 # Copyright (c) 2013 Qualcomm Atheros, Inc.
 #
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted (subject to the limitations in the
 # disclaimer below) provided that the following conditions are met:
 #
 #  * Redistributions of source code must retain the above copyright
 #    notice, this list of conditions and the following disclaimer.
 #
 #  * Redistributions in binary form must reproduce the above copyright
 #    notice, this list of conditions and the following disclaimer in the
 #    documentation and/or other materials provided with the
 #    distribution.
 #
 #  * Neither the name of Qualcomm Atheros nor the names of its
 #    contributors may be used to endorse or promote products derived
 #    from this software without specific prior written permission.
 #
 # NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE
 # GRANTED BY THIS LICENSE.  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT
 # HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
 # WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 # MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 # DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 # LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 # BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 # WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 # OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 # IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ##

all:
	[ -d build ] || ./configure || { rm -rf build; false; }
	+$(MAKE) -C build/k2
	+$(MAKE) -C build/magpie
	cp build/k2/htc_*.fw build/magpie/htc_*.fw .

clean:
	rm -rf build htc_*.fw

## open-ath9k-htc-firmware 1.4.0-110-ge888634+dfsg1

=== debian/changelog ===
open-ath9k-htc-firmware (1.4.0-110-ge888634+dfsg1-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Force higher min cmake version. (Closes: #1113348)

 -- Bastian Germann <bage@debian.org>  Fri, 10 Oct 2025 11:35:02 +0200

open-ath9k-htc-firmware (1.4.0-110-ge888634+dfsg1-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream snapshot 1.4.0-110-ge888634+dfsg1.
  * Build cross compiler with GCC 14.
  * Allow discarded qualifiers.

  [ John Scott ]
  * Add a Salsa CI configuration file to disable blhc.
  * Properly denote my comment in the Salsa CI config file.

 -- Bastian Germann <bage@debian.org>  Sun, 05 Jan 2025 13:10:18 +0000

open-ath9k-htc-firmware (1.4.0-108-gd856466+dfsg1-1.5) unstable; urgency=medium

  * Non-maintainer upload.
  * Install all files below /usr. (Closes: #1059414)

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 30 May 2024 01:01:56 +0200

open-ath9k-htc-firmware (1.4.0-108-gd856466+dfsg1-1.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Add notes on how to generate modaliases.
  * Remove Qwest/Actiontec 802AIN ID.
  * Prevent requesting dev firmware. (Closes: #1038684)

 -- Bastian Germann <bage@debian.org>  Wed, 26 Jul 2023 21:09:48 +0200

open-ath9k-htc-firmware (1.4.0-108-gd856466+dfsg1-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * DEP-11: Add AirTies and Altai WA1011N-GU. (Closes: #1031935)
  * DEP-11: Add firmware provides.

 -- Bastian Germann <bage@debian.org>  Sat, 25 Feb 2023 20:37:02 +0100

open-ath9k-htc-firmware (1.4.0-108-gd856466+dfsg1-1.2) unstable; urgency=high

  * Non-maintainer upload.
  * Breaks/Replaces on firmware-atheros. (Closes: #1031197)
  * metadata: Remove Homepage field.

 -- Bastian Germann <bage@debian.org>  Mon, 13 Feb 2023 14:27:16 +0100

open-ath9k-htc-firmware (1.4.0-108-gd856466+dfsg1-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * Rename to stable firmware file name. (Closes: #1031186)

  [ Debian Janitor ]
  * Update lintian override info format in d/source/lintian-overrides on line 6.
  * Set upstream metadata fields: Bug-Submit, Repository.
  * Remove obsolete field Contact from debian/upstream/metadata (already present
    in machine-readable debian/copyright).
  * Update standards version to 4.6.2, no changes needed.

 -- Bastian Germann <bage@debian.org>  Sun, 12 Feb 2023 22:34:38 +0100

=== debian/control ===
--- 
+++ 
@@ -8,11 +8,11 @@
  cmake,
  debhelper-compat (= 13),
  flex,
- gcc-12-source,
+ gcc-14-source,
  libmpc-dev,
  zlib1g-dev
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/open-ath9k-htc-firmware
 Vcs-Git: https://salsa.debian.org/debian/open-ath9k-htc-firmware.git
 Homepage: https://github.com/qca/open-ath9k-htc-firmware
@@ -22,6 +22,8 @@
 Multi-Arch: foreign
 Depends:
  ${misc:Depends}
+Breaks: firmware-atheros (<= 20230210-1)
+Replaces: firmware-atheros (<= 20230210-1)
 Description: firmware for AR7010 and AR9271 USB wireless adapters
  The Qualcomm Atheros AR7010 and AR9271 chipsets are used in USB
  wireless adapters which are 802.11n-capable. This package contains

=== debian/rules ===
--- 
+++ 
@@ -6,13 +6,16 @@
 # Stack protector needs to be disabled since that entails linking to libssp.
 # Other hardening flags likewise cause more problems than they solve.
 export DEB_BUILD_MAINT_OPTIONS=hardening=-all
+export DEB_CFLAGS_MAINT_APPEND=-Wno-error=discarded-qualifiers
 
-# This avoids clashing with the file in firmware-nonfree.
-FW_FILENAME_VER = 1.dev.0
+FW_FILENAME_VER = 1.4.0
 
 %:
 	CROSS_COMPILE="$(toolchain_dir)/bin/xtensa-elf-" \
 	dh $@ --buildsystem=makefile --sourcedirectory=target_firmware
+
+override_dh_auto_configure:
+	dh_auto_configure -- -DCMAKE_POLICY_VERSION_MINIMUM=3.5
 
 override_dh_auto_build: $(stamp)gcc_xtensa-elf
 	dh_auto_build --

=== debian/watch ===
version=4
# pretty=describe needlessly switches out the hyphens for periods, so we undo it.
opts="dversionmangle=auto, repacksuffix=+dfsg1, mode=git, uversionmangle=s/(\d\.\d\.\d)\.(.+)\.(.+)/$1-$2-$3/, pretty=describe" \
	https://github.com/qca/@PACKAGE@.git HEAD debian
